#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

# Define the script path
wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationApp

def wsadminToList(inStr):
	outList=[]
	if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
		tmpList = inStr[1:-1].split() #splits space-separated lists,
	else:
		tmpList = inStr.split("\n")   #splits for Windows or Linux

	for item in tmpList:
		item = item.rstrip();         #removes any Windows "\r"
		if (len(item)>0):
			outList.append(item)
	return outList
#endDef   

def getNodename():
	nodeName = WPSMigrationUtil.getSystemProperty("bpm.upgrade.node.name")
	if ( nodeName == ''):
		#configuration = AdminTask.reportConfiguredPorts()
		#configurationList = wsadminToList(configuration)
		#node = configurationList[1].rstrip()
		#nodeList1 = node.split('/')
		#node1 = nodeList1[0]
		#nodeList2 = node1.split(' ')
		#node2 = nodeList2[1]
		#return node2
		nodelist = AdminConfig.list("Node" )
		nodeArr = wsadminToList(nodelist)
		node = nodeArr[0]
		nodeNameStr = AdminConfig.show(node, "name")
		nodeNameList = wsadminToList(nodeNameStr)                
		nodeName = nodeNameList[1]
		PrintHelper.printInfo("bpm.upgrade.node.name=\"\". get node name from AdminConfig.list('Node')="+nodeName)
	else:
		PrintHelper.printInfo("Get node name with property bpm.upgrade.node.name="+nodeName)

	return nodeName;
#end def getNodeName()

def migrateApp(exportEarFile, appName, configurationFile):
	migrationWorkDir = WPSMigrationUtil.getMigrationWorkDir()
	try:
		nodename = getNodename()

		# Export the application to ear file under the migration working directory
		#exportEarFile = migrationWorkDir+appName+".ear"
		#AdminApp.export(appName, exportEarFile)
		#PrintHelper.printInfo("----Export app "+appName+" to file: "+exportEarFile)

		# Migrate the applications and use the new application jar files to update applications
		migrationApp = WPSMigrationApp(exportEarFile, migrationWorkDir, nodename, configurationFile)
		#updatedEar = migrationApp.doFullEarMigration()
		#updateCmd = "[-operation update -contents " + updatedEar + "]"
		#AdminApp.update(appName, "app", updateCmd)
		returnStrs = migrationApp.doAppMigration()
		PrintHelper.printInfo("----Updating the application "+appName)
		i=1
		while i<len(returnStrs):
			updateJar = returnStrs[0]+returnStrs[i]
			updateCmd = "[-operation update -contents " + updateJar + " -contenturi " + returnStrs[i] + "]"
			AdminApp.update(appName, "file", updateCmd)
			i=i+1

		AdminConfig.save()
	except:
		PrintHelper.printInfo("")

	# Delete the Work Dir
	if ( WPSMigrationUtil.toRemoveTempFiles() ):
		WPSMigrationUtil.deleteFile(migrationWorkDir)
# end

def migrateStandaloneApp(appName, configurationFile):
	PrintHelper.printInfo("----Starting to Migrate Stand Alone application = "+appName)
	migrationWorkDir = WPSMigrationUtil.getMigrationWorkDir()

	try:
		# Export the application to ear file under the migration working directory
		exportEarFile = migrationWorkDir+appName+".ear"
		AdminApp.export(appName, exportEarFile)
		migrateApp(exportEarFile, appName, configurationFile)
		PrintHelper.printInfo("----Stand alone application migration Done for app = "+appName)
	except:
		PrintHelper.printInfo("----FAIL: Stand alone application migration failed for app = "+appName)

	# Delete the Work Dir
	if ( WPSMigrationUtil.toRemoveTempFiles() ):
		WPSMigrationUtil.deleteFile(migrationWorkDir)
#end