#BEGIN COPYRIGHT
#************************************************************************************
# IBM Confidential
# OCO Source Materials
# 5639-D57,5630-A36,5630-A37,5724-D18
# @ Copyright IBM Corporation 2010.
# The source code for this program is not published or otherwise
# divested of its trade secrets, irrespective of what has been
# deposited with the U.S. Copyright Office.
#*************************************************************************
#END COPYRIGHT
# script to update stanalone RAR, includes save connection factory, save activation spec, uninstall RAR , install RAR, create connection factory, create activation spec
# script take 2 inputs.. adapter rarname, new RAR path

#For Example...
#C:\WID62\runtimes\bi_v62\bin>wsadmin -lang jython -f 
#updateStandaloneRAR.py "IBM WebSphere Adapter for FTP" "C:/temp/CWYFT_FTPFile.rar" 

import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil
from com.ibm.wbicore.migration.profileupgrade import WBIProfileUpgradeHelper
from java.lang import System

#wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
#fileSeparator=WPSMigrationUtil.getFileSeparator()
#scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
#sys.path.append(scriptsPath)

# Retrieve the value of WPS HOME from system environment property
wpsRootPath = WPSMigrationUtil.getSystemProperty("was.install.root")
# Define the script path
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)
import printHelper as PrintHelper
import updateStandaloneAdapter as UpdateStandAloneAdapter
import findStandaloneRAApplications as FindStandAloneRAApps
import migrateApp as MigrateApp

def setMetadataProperties():
	processAppInfoPy = wpsRootPath + fileSeparator + "util" + fileSeparator + "upgrade" + fileSeparator + "ProcessApplicationInformation.py"
	PrintHelper.printInfo("processAppInfoPy="+processAppInfoPy)
	#execfile(processAppInfoPy)
	execfile(processAppInfoPy, globals().copy())
#end def setMetadataProperties():

def getNodeType():
	nodeType = System.getProperty("bpm.upgrade.node.type")
	return nodeType
#end def getNodeType

#-------------------------------------------------------------------------------------------
#  Sub modules for standalone adapters/applications migration
#-------------------------------------------------------------------------------------------
def migrateStandAloneRAApps(configurationFile):
	raStandaloneRAAppList = FindStandAloneRAApps.findStandaloneRAApps()
	PrintHelper.printInfo("starting to migrate stand alone adapter and applications...")
	PrintHelper.printInfo(raStandaloneRAAppList)
	try:
		for oneNode in raStandaloneRAAppList:
			nodeName = oneNode[0]
			nodeID = oneNode[1]
			raApplicationList = oneNode[2]
			for raApplication in raApplicationList:
				raID = raApplication[0]
				raName = raApplication[1]
				raDisplayName = raApplication[2]
				raVersion = raApplication[3]
				raMCFList = raApplication[4]
				raASList = raApplication[5]
				appsList = raApplication[6]
				PrintHelper.printInfo("WebSphere Adapter is "+raName)
				
				for appName in appsList:
					MigrateApp.migrateStandaloneApp(appName, configurationFile)
					
				dir = WPSMigrationUtil.getMigrationWorkDir()
				UpdateStandAloneAdapter.saveMCFprop( dir, raDisplayName, raMCFList )
				UpdateStandAloneAdapter.saveASprop( dir, raDisplayName, raASList, raID )
				UpdateStandAloneAdapter.saveClasspath( dir, raDisplayName, raID )
				
				UpdateStandAloneAdapter.removeRAR(raID,raName,raDisplayName)
				PrintHelper.printInfo("---removed RAR "+ raName + "on node="+nodeName+"---")
				UpdateStandAloneAdapter.installRAR(raName,raDisplayName,nodeName)
				PrintHelper.printInfo("---installeded RAR "+ raName + "on node="+nodeName+"---")
				
				cell = AdminConfig.list('Cell').split(lineSeparator)[0]
				cellname = cell.split('(')[0]
				id = "/Cell:"+cellname+"/Node:"+nodeName + "/J2CResourceAdapter:" + raName +"/"
				raID = AdminConfig.getid(id)
				
				PrintHelper.printInfo("Recovering CF/AS for stand alone adapter="+raName+" on node="+nodeName)
				propertyFiles = WPSMigrationUtil.getAllFilesInFolder(dir, ".properties")
				for file in propertyFiles:
					if(file.find(raDisplayName + "_RA_") == 0):
						raProperty = UpdateStandAloneAdapter.getPropertiesFromFile(dir + file)
						UpdateStandAloneAdapter.createRAproperty(raID,raProperty)
					else:
						if (file.find(raDisplayName+"_CF_") == 0):
							mcfProperty = UpdateStandAloneAdapter.getPropertiesFromFile(dir + file)
							UpdateStandAloneAdapter.createConnectionFactory(raID,mcfProperty)
						else:
							if(file.find(raDisplayName+"_AS_") == 0):
								asProperty = UpdateStandAloneAdapter.getPropertiesFromFile(dir + file)
								UpdateStandAloneAdapter.createActivationSpec(dir,raID,raDisplayName,asProperty)
				#end for file in propertyFiles:
				if ( WPSMigrationUtil.toRemoveTempFiles() ):
					WPSMigrationUtil.deleteFile(dir)
			
			#end for raApplication in raApplicationList:
	except:
		PrintHelper.printInfo("Encounter error:")
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	#endfor
#end def migrateStandAloneRAApps

#-------------------------------------------------------------------------------------------
#  Main program
#-------------------------------------------------------------------------------------------
if __name__ == "__main__":
	# Set the environment property value: WPS_HOME
	PrintHelper.printInfo("WPS_HOME = "+wpsRootPath)
	WPSMigrationUtil.setWPSHome(wpsRootPath)

	# Set the value for new adapter RAR path
	newRARFolder=wpsRootPath+fileSeparator+"installableApps"+fileSeparator
	WPSMigrationUtil.setNewRARDir(newRARFolder)

	# Set the environment property value
	i = 0 #forStart
	while ( i < len(sys.argv) ): #forTest
		arg = sys.argv[i]
		if (arg == "-migrationDir"):
			i = i+1
			arg = sys.argv[i]
			System.setProperty("wbi.upgrade.backup.dir", arg)
			System.setProperty("bpm.upgrade.backup.dir", arg)
		#endIf

		if (arg == "-bpm.upgrade.previous.profileName"):
			i = i+1
			arg = sys.argv[i]
			if (arg == "{}"):
				continue
			System.setProperty("wbi.upgrade.previous.profileName", arg)
			System.setProperty("bpm.upgrade.previous.profileName", arg)
		#endIf
		i+=1
	#endWhile
	helper = WBIProfileUpgradeHelper(System.getProperty("was.install.root"), System.getProperty("was.repository.root"), System.getProperty("bpm.upgrade.backup.dir"))
	System.setProperty("wbi.upgrade.node.type", helper.getNodeType() )
	System.setProperty("bpm.upgrade.node.type", helper.getNodeType() )
	
	# Set the environment property value for migration temp folder
	tempFolder=WPSMigrationUtil.getSystemProperty("bpm.upgrade.backup.dir")
	WPSMigrationUtil.setTempDir(tempFolder)

	configurationFile = scriptsPath+"adapterMigrationInfo.xml"
	PrintHelper.printInfo("----Loading configuration info from "+configurationFile)
	WPSMigrationUtil.getAdapterMigrationInfo(configurationFile)

	nodeType = getNodeType()
	if ( nodeType == "dmgr" or nodeType == "unmanaged" ):
		PrintHelper.printInfo("---This script only run for standalone adapter migration on managed node...")
		PrintHelper.printInfo("---Current node type="+nodeType+". Skip it...")
	else:
		PrintHelper.printInfo("Temp Folder = "+tempFolder)
		
		# set the metadata value for migration
		PrintHelper.printInfo("----set the metadata property value")
		setMetadataProperties()
		# migrate the standalone adapter/app on this node
		PrintHelper.printInfo("----Migrating standalone adapters on managed nod")
		migrateStandAloneRAApps(configurationFile)
		PrintHelper.printInfo("----Done standalone adapters migration on managed node")

#end of main program